<?php
/**
 * NOTICE OF LICENSE
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * You must not modify, adapt or create derivative works of this source code
 *
 * @author    Parcelpro
 * @copyright 2020 Parcelpro
 * @license   LICENSE.txt
 */

class AdminParcelproController extends ModuleAdminController
{
    public function postProcess()
    {
        parent::postProcess();

        if (Tools::isSubmit('submitShipment')) {
            $orderId = Tools::getValue("orderId");

            $parcelproId = Configuration::get('parcelproId');
            $parcelproApiKey = Configuration::get('apiKey');

            $wrapper = new ParcelProAPIWrapper($parcelproId, $parcelproApiKey);

            if ($wrapper->validate()) {
                $shipments = json_decode($wrapper->shipments(), true);

                $filtered = array_values(array_filter($shipments, function ($shipment) use ($orderId) {
                    return $shipment["OrderNr"] == $orderId;
                }));

                $shipment = reset($filtered);

                $label = $wrapper->getLabel($shipment["Id"]);

                $file = $shipment["Id"] . ".pdf";

                file_put_contents($file, "");

                file_put_contents($file, $label, FILE_APPEND | LOCK_EX);

                header(sprintf("Content-type: application/%s;", "pdf"));
                header(sprintf("Content-Disposition: attachment;filename=%s", basename($file)));
                readfile($file);

                return;
            }
        }
    }
}
