<?php
/**
 * NOTICE OF LICENSE
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * You must not modify, adapt or create derivative works of this source code
 *
 * @author    Parcelpro
 * @copyright 2020 Parcelpro
 * @license   LICENSE.txt
 */

namespace Parcelpro\Controller\Admin;

require _PS_MODULE_DIR_ . 'parcelpro/helperpresta.php';

use Configuration;
use Order;
use Tools;
use PrestaShopBundle\Controller\Admin\FrameworkBundleAdminController;
use ParcelProAPIWrapper;

class AdminParcelproOrdersController extends FrameworkBundleAdminController
{
    public function printLabels()
    {
        $api = new ParcelProAPIWrapper(Configuration::get('parcelproId'), Configuration::get('apiKey'));
        $orderIds = Tools::getValue('order_orders_bulk');
        $shipments = [];

        if ($api->validate()) {
            foreach ($orderIds as $orderId) {
                $order = new Order($orderId);

                $data = [
                    'orderId' => $orderId,
                    'reference' => $order->reference
                ];

                $shipment = json_decode($api->shipments($data), true);
                $shipment = reset($shipment);

                array_push($shipments, $shipment['Id']);
            }
        }

        $hash = $api->createHash(Configuration::get('parcelproId') . reset($shipments));
        $parameters = [
            'GebruikerId' => Configuration::get('parcelproId'),
            'ZendingId' => reset($shipments),
            'HmacSha256' => $hash,
            'PrintPdf' => 1
        ];

        foreach ($shipments as $shipment) {
            $parameters['selected[]'][] = $shipment;
        }

        $url = $api->apiUrl() . 'label.php?' . http_build_query($parameters, '', '&') . '&' . implode('&', $shipments);
        Tools::redirect($url);

        return $this->render(_PS_MODULE_DIR_ . '/parcelpro/views/templates/admin/orders.tpl', []);
    }
}
