<?php
/**
 * NOTICE OF LICENSE
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * You must not modify, adapt or create derivative works of this source code
 *
 * @author    Parcelpro
 * @copyright 2020 Parcelpro
 * @license   LICENSE.txt
 */

class ParcelproParcelshopModuleFrontController extends ModuleFrontController
{
    public function initContent()
    {
        parent::initContent();

        $this->setTemplate('module:parcelpro/views/templates/front/parcelshop.tpl');
    }

    public function postProcess()
    {
        parent::postProcess();

        $cartId = $this->context->cart->id;
        $pickupPointId = Tools::getValue('pickupPointId') ? Tools::getValue('pickupPointId') : null;
        $locationType = Tools::getValue('locationType') ? Tools::getValue('locationType') : null;
        $name = Tools::getValue('name') ? Tools::getValue('name') : null;
        $street = Tools::getValue('street') ? Tools::getValue('street') : null;
        $houseNumber = Tools::getValue('houseNumber') ? Tools::getValue('houseNumber') : null;
        $houseNumberAdditional = Tools::getValue('houseNumberAdditional') ?
            Tools::getValue('houseNumberAdditional') : null;
        $postal = Tools::getValue('postal') ? Tools::getValue('postal') : null;
        $city = Tools::getValue('city') ? Tools::getValue('city') : null;

        $get = new DbQuery();
        $get->select('*')->from('cart_pickup_points')->where('cart_id = ' . (int)$cartId);

        $selectedLocation = $this->l('selectedLocation');
        $this->context->smarty->assign(
            compact('name', 'street', 'houseNumber', 'houseNumberAdditional', 'postal', 'city', 'selectedLocation')
        );

        if (empty(Db::getInstance()->executeS($get))) {
            if (Tools::getValue("delete")) {
                return;
            }

            Db::getInstance()->insert('cart_pickup_points', [
                'cart_id' => (int)$cartId,
                'pickup_point_id' => (int)$pickupPointId,
                'location_type' => pSQL($locationType),
                'name' => pSQL($name),
                'street' => pSQL($street),
                'house_number' => pSQL($houseNumber),
                'house_number_additional' => pSQL($houseNumberAdditional),
                'postal' => pSQL($postal),
                'city' => pSQL($city)
            ]);
        } else {
            if (Tools::getValue("delete")) {
                Db::getInstance()->delete('cart_pickup_points', 'cart_id = ' . (int)$cartId, 1);
            } else {
                Db::getInstance()->update('cart_pickup_points', [
                    'pickup_point_id' => (int)$pickupPointId,
                    'name' => pSQL($name),
                    'street' => pSQL($street),
                    'house_number' => (int)$houseNumber,
                    'house_number_additional' => pSQL($houseNumberAdditional),
                    'postal' => pSQL($postal),
                    'city' => pSQL($city)
                ], 'cart_id = ' . (int)$cartId);
            }
        }
    }
}
