{*
* NOTICE OF LICENSE
*
* This file is licenced under the Software License Agreement.
* With the purchase or the installation of the software in your application
* you accept the licence agreement.
*
* You must not modify, adapt or create derivative works of this source code
*
*  @author    Parcelpro
*  @copyright 2020 Parcelpro
*  @license   LICENSE.txt
*}

<input type="hidden" id="addressId" value="{$addressId|escape:'htmlall':'UTF-8'}">
<input type="hidden" id="carriers" value="{$carriers|escape:'htmlall':'UTF-8'}">
<input type="hidden" id="ajaxLink" value="{$ajax|escape:'htmlall':'UTF-8'}">

<div id="selectedLocation" class="flex-container">
    {if isset($pickupPoint['name'] && !empty($pickupPoint['name']))}
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <h5>{$selectedLocation|escape:'htmlall':'UTF-8'}</h5>
            <p>{$pickupPoint['name']|escape:'htmlall':'UTF-8'}</p>
            <p>{$addressText|escape:'htmlall':'UTF-8'}</p>
            <p>{$pickupPoint['postal']|escape:'htmlall':'UTF-8'} {$pickupPoint['city']|escape:'htmlall':'UTF-8'}</p>
        </div>
    {/if}
</div>

<script type="text/javascript">
    var carriers = JSON.parse(document.querySelector('#carriers').value);
    carriers.forEach(function (carrierId) {
        var servicepoint = document.querySelector('#servicepoint-' + carrierId) ? document.querySelector('#servicepoint-' + carrierId).value : null;
        var carrier = document.querySelector('#delivery_option_' + carrierId);
        var checked = carrier ? carrier.checked : false;

        if (checked && servicepoint) {
            window.carrierId = carrierId;
            if (document.querySelector('#checkout-delivery-step')) {
                if (!document.querySelector('#checkout-delivery-step').classList.contains('-complete')) {
                    showModal(carrierId);
                }
            } else {
                showModal(carrierId);
            }
        }

        if (carrier) {
            carrier.addEventListener('click', function (event) {
                console.log("event");
                console.log(event);
                if (event.pointerType == 'mouse') {
                    window.carrierId = parseInt(event.target.value);
                    deleteLocation();

                    if (servicepoint) {
                        showModal(parseInt(event.target.value));
                    }
                }
            });
        }
    });

    window.addEventListener('message', function (event) {
        if (event.origin == 'https://login.parcelpro.nl') {
            if (event.data == 'closewindow') {
                // $("div[id^='mapModal']").modal('hide');
                hideModal(window.carrierId);
            } else {
                selectLocation(event.data);
            }
        }
    });

    function showModal(carrierId) {
        document.getElementById('mapModal-' + carrierId).style.display = 'block';
        document.getElementById('mapModal-' + carrierId).classList.add('show');
    }

    function hideModal(carrierId) {
        document.getElementById('mapModal-' + carrierId).style.display = 'none'
        document.getElementById('mapModal-' + carrierId).classList.remove('show')
    }

    function selectLocation(location) {
        $.ajax({
            url: document.querySelector('#ajaxLink').value,
            method: 'POST',
            data: {
                pickupPointId: location.Id,
                locationType: location.LocationType,
                name: location.Name,
                street: location.Street,
                houseNumber: location.Housenumber,
                houseNumberAdditional: location.HousenumberAdditional,
                postal: location.Postalcode,
                city: location.City
            },
            success: function (result) {
                if (document.querySelector('#selectedLocation')) {
                    document.querySelector('#selectedLocation').innerHTML = result;
                }
            }
        });
    }

    function deleteLocation() {
        $.ajax({
            url: document.querySelector('#ajaxLink').value,
            method: 'POST',
            data: {
                delete: true
            },
            success: function () {
                if (document.querySelector('#selectedLocation')) {
                    document.querySelector('#selectedLocation').innerHTML = '';
                }
            }
        });
    }
</script>